
/****************************************************************************
This program is for testing the interface between BF537 blackfin PPI and FPGA
Written By: S.M. Hasan, hasan@vt.edu
*****************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <limits.h>


#include "ppi.h"
#include "ppiFM.h"



UINT16 *IQ;

int main(int argc,char *argv[])
{
	// Setting up variables and default values

	int	ppiFD, n, i, j;
	char	mode;
	int	retval;
	UINT16	bufX = LINELEN;
	UINT16	bufY = NUMLINES;
	int	dims, size;
	size = BUFFERSIZE;
	dims = DIM2D;
	//char	buf[size];
	UINT16 i_in_raw[size/2], q_in_raw[size/2];
	short i_in[size/2], q_in[size/2];
	FILE *ofp, *ofpi, *ofpq;

	// Variables initialization
/*	i=0;
	char ofilename[] = "out.txt";
	char ofilename1[] = "i_in.txt";
	char ofilename2[] = "q_in.txt";
	
	// PPI Initialization 
	
	if (argc < 2){
		showUsage(argv[0]);
		return(1);
	}
	else {
		mode = *argv[1];
	}
*/	
	ppiFD = open("/dev/ppi0", O_RDWR);

	if (ppiFD < 0)
	{
		perror("Error opening /dev/ppi");
		return(-1);
	}
	else {
		printf("fd(%d) = open(/dev/ppi) \n", ppiFD );
	}
	// PPI Data Transmitting
	printf("beMaster() \n");
	beMaster(ppiFD, bufX, bufY, dims);

	// File initializations
/*	ofp = fopen(ofilename,"w");
    	ofpi = fopen(ofilename1,"w");
    	ofpq = fopen(ofilename2,"w");
*/
	//sleep(3);
	
	closePPI(ppiFD);

	sleep(3);
	
	ppiFD = open("/dev/ppi0", O_RDWR);

	if (ppiFD < 0)
	{
		perror("Error opening /dev/ppi");
		return(-1);
	}
	else {
		printf("fd(%d) = open(/dev/ppi) \n", ppiFD );
	}


	// PPI data reading
	printf("beSlave()\n");
	beSlave(ppiFD, IQ, bufX, bufY, dims);
/*
	for (n=0; n<size; n++)			// testing the incoming data directly from PPI
		{
			printf("Printing IQ values in main [%d]= %4hX\n", n, *IQ);
			//fprintf(ofp,"%d\n", *IQ);
			//fprintf(ofpi,"%d\n",i_in_raw[j]);				// writing received data into a file
			//fprintf(ofpq,"%d\n",q_in_raw[j]);
			IQ++;
		}
*/


        /* Close Files */
 /*   	fclose(ofp);
    	fclose(ofpi);
    	fclose(ofpq);    
 */   
   	//printf ("Output is written into a file 'out.txt'..... \n");
   	printf ("Ended the program ....... \n");
	
	

	// PPI Closing
	closePPI(ppiFD);
	
	printf ("Main Program finished \n");
	return (0);

}
